.586
.model flat, stdcall
 option casemap :none
      
   include        /masm32/include/windows.inc
   include        /masm32/include/kernel32.inc
   include        /masm32/include/user32.inc
   include        /masm32/include/comctl32.inc
   
   includelib     /masm32/lib/kernel32.lib
   includelib     /masm32/lib/user32.lib
   includelib     /masm32/lib/comctl32.lib
   
           
   WinMain        PROTO :DWORD,:DWORD,:DWORD,:DWORD
   WndProc        PROTO :DWORD,:DWORD,:DWORD,:DWORD
   TopXY          PROTO :DWORD,:DWORD
   
.data
   ClassName      db "Example",0
   CaptionText    db "Example",0
   ButtonClass    db "button",0
   txtTest        db "test",0  
       
.data?
   hWnd            HANDLE ?
   hInstance       HANDLE ? 

.code
 start:
 
   invoke GetModuleHandle, NULL      
   mov hInstance, eax
   invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
   invoke ExitProcess,eax

; ########################################################################

WinMain proc hInst:DWORD, hPrevIns:DWORD, CmdLine:DWORD, CmdShow:DWORD

   LOCAL  wc   :WNDCLASSEX
   LOCAL  msg  :MSG
   LOCAL  Wwd  :DWORD
   LOCAL  Wht  :DWORD
   LOCAL  Wtx  :DWORD
   LOCAL  Wty  :DWORD
   
   mov    wc.cbSize,       SIZEOF WNDCLASSEX
   mov    wc.style,        CS_HREDRAW + CS_VREDRAW
   mov    wc.lpfnWndProc,  OFFSET WndProc
   mov    wc.cbClsExtra,   NULL
   mov    wc.cbWndExtra,   NULL
   mov    eax,             hInstance
   mov    wc.hInstance,    eax
   invoke LoadIcon,        NULL,IDI_HAND
   mov    wc.hIcon,        eax
   mov    wc.hIconSm,      eax
   invoke LoadCursor,      NULL,IDC_ARROW
   mov    wc.hCursor,      eax
   mov    wc.hbrBackground,COLOR_BTNFACE+1
   mov    wc.lpszMenuName, NULL
   mov    wc.lpszClassName,OFFSET ClassName
   invoke RegisterClassEx, addr wc
   
   mov    Wwd, 200
   mov    Wht, 100
   
   invoke GetSystemMetrics,SM_CXSCREEN
   invoke TopXY,Wwd,eax
   mov    Wtx, eax
   
   invoke GetSystemMetrics,SM_CYSCREEN
   invoke TopXY,Wht,eax
   mov    Wty, eax
   
   invoke CreateWindowEx, 0,
                          ADDR ClassName,
                          ADDR CaptionText,
                          WS_OVERLAPPED + WS_SYSMENU + WS_MINIMIZEBOX  + WS_CAPTION,
                          Wtx,Wty,Wwd,Wht,
                          NULL,
                          NULL,
                          hInst,
                          NULL
   mov    hWnd,eax
   invoke ShowWindow,hWnd,SW_SHOWNORMAL
   invoke UpdateWindow,hWnd
   
   StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
   ExitLoop:

      mov eax,msg.wParam
      ret
   
WinMain endp

; ###############################################################################################################################
WndProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

   .IF uMsg == WM_CREATE     
    invoke CreateWindowEx, 0,
                           addr ButtonClass,
                           addr txtTest,
                           WS_CHILD + WS_VISIBLE + BS_AUTOCHECKBOX,
                           60,30,100,20,
                           hWin,
                           0,
                           hInstance,
                           0
                           

   .ELSEIF uMsg == WM_DESTROY
      invoke PostQuitMessage,NULL
   .ELSE
      invoke DefWindowProc,hWin,uMsg,wParam,lParam		
      ret
   .ENDIF
      xor eax,eax
      ret

WndProc endp
;==============================================================
TopXY proc wDim:DWORD, sDim:DWORD
    shr sDim, 1
    shr wDim, 1
    mov eax, wDim
    sub sDim, eax
    ret
TopXY endp
;==============================================================
end start